﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ploeh.Samples.TennisKata
{
    public interface IPoints
    {
        IPoints Accept(IPoints visitor);

        IPoints LoseBall();

        IPoints WinBall(IPoints opponentPoints);

        IPoints WinBall(AdvantagePoint opponentPoints);

        IPoints WinBall(FortyPoints opponentPoints);
    }
}
